
//INPUTS:
int dimmerPin = A1;
int holdButtonPin = A0;
int burstButtonPin = 0;

//OUTPUTS:
int counterPin = 9;
int servoPin = 5;
int cloudPin = 1;

//VARIABLES:
int dimmerValue = 0;          // the analog value of the dimmer
int dimmerPWMValue = 0;
int dimmerTime = 0;           // the number of seconds the timer will run
int dimmerPWMTime = 0;        // the number of hold seconds will be translated into an PWM value so the number bit will display it during the countdown
int burstTime = 0;            // the number of seconds the water has been flowing
int burstPWMTime = 0;         // the number of burst seconds will be translated into an PWM value so the number bit will display it during the countdown

int holdButtonState = 0;      // store whether the hold button is pushed or not
int burstButtonState = 0;     //stores whether the burst button is pushed or not

int servoPush = 1400;
int servoNoPush = 255;


void setup()
{
  pinMode(dimmerPin, INPUT);
  pinMode(holdButtonPin, INPUT);
  pinMode(burstButtonPin, INPUT);
  pinMode(counterPin, OUTPUT);
  pinMode(servoPin, OUTPUT);
  pinMode(cloudPin, OUTPUT);
  
  // Serial.begin(9600);
  
  
    
}

void loop()
{
  int clockValues[] = {0,3,5,7,9,11,15,17,19,22,25,28,29,32,35,38,39,42,44,47,51,53,57,59,60,62,65,69,70,72,75,78,82,84,85,87,91,93,96,97,101,103,106,109,111,112,115,117,121,124,126,128,132,134,135,137,141,143,145,147,150,154,156,158,160,163,165,168,171,174,177,179,181,184,186,188,190,192,195,197,202,204,206,210,212,214,217,219,221,224,227,230,233,235,237,240,242,244,246,250};
  
  dimmerValue = analogRead(dimmerPin);                    // Read the dimmer
  dimmerPWMValue = map(dimmerValue, 0, 1023, 0, 255);     // Convert the analog value of the dimmer to a PWM value for output
  analogWrite(counterPin, dimmerPWMValue);                // Display the value set by the dimmer on the counter module
  dimmerTime = map(dimmerValue, 0, 1023, 0, 99);          // Convert the dimmer reading to a number between 0 and 99 seconds

  holdButtonState = digitalRead(holdButtonPin);           // Read the value of the Hold Button and store it
  burstButtonState = digitalRead(burstButtonPin);         // Read the value of the Burst Button and store it
  
  // COUNTDOWN TIMER WATER //

  if (holdButtonState == HIGH)                            // If the Hold Button is pushed....
  {
    for(int time = dimmerTime - 1; time >= 0; time--)         // Start a counter that counts down from the value set by the dimmer and stops at 0
    {
      analogWrite(servoPin, servoPush);                          // Set the servo to push the water button
      dimmerTime--;                                       // Incriment the counter down one
      delay(1000);                                        // Wait 1 second
      // Serial.println(dimmerTime);
      // Serial.println(clockValues[dimmerTime]);
      analogWrite(counterPin, clockValues[dimmerTime]);   // Write the analog value that corresponds with the time reading for the clock
      // dimmerPWMTime = map(dimmerTime, 0, 99, 0, 255);     // Translate the counter value to a PWM signal for the Counter Module
      holdButtonState = digitalRead(holdButtonPin);       // Read the Hold Button
      if (holdButtonState == HIGH)                        // If the Hold Button has been pushed...
      {                  
        analogWrite(servoPin, servoNoPush);                         // Stop pushing the water button
        delay(2000);                                      // Wait 2 seconds (for user to stop pushing the button)
        break;                                            // Break out of the loop
      }
    }
    analogWrite(servoPin, servoNoPush);                   // if the counter gets all the way down to 0, stop pushing the water button
    digitalWrite(cloudPin, HIGH);                         // Send a signal to the cloud module to log the event
    delay(1000);
    digitalWrite(cloudPin, LOW);                          // Turn off the signal to the cloud module
  }
  
  // COUNTUP TIMER WATER //
  
else if (burstButtonState == HIGH)
  {
    
     analogWrite(servoPin, servoPush);                              // Set the servo to push the water button

    /*
    burstTime = 0;                                            // Set the burst time to 0 seconds
    while (burstButtonState == HIGH)                          // As long as the button is pushed...
    {
      burstButtonState = digitalRead(burstButtonPin);         // Read the value of the Burst Button and store it
      analogWrite(counterPin, clockValues[burstTime]);        // Write the analog value that corresponds with the time reading for the clock
      analogWrite(servoPin, servoPush);                              // Set the servo to push the water button
      burstTime ++;                                           // increment the burst time by 1 second
      delay(1000);                                            // wait 1 second
    }
    */
   
  }
  
else
  {
    analogWrite(servoPin, servoNoPush);                              // If neither button is pressed, set the servo signal to 0
  }
}

